﻿//Author: Rodolfo Finochietti - http://weblogs.shockbyte.com.ar/rodolfof
using System;
using System.Linq;
using System.Windows.Forms;

namespace LINQToDataSet.TypedDataSet
{
    public partial class MainForm : Form
    {
        public MainForm( )
        {
            InitializeComponent( );
        }

        private void MainForm_Load( object sender, EventArgs e )
        {
            #region Load DataSet Code

            salesOrderHeaderTableAdapter1.Fill( orderDataSet1.SalesOrderHeader );
            salesOrderDetailTableAdapter1.Fill( orderDataSet1.SalesOrderDetail );

            #endregion

            //2.1 Join
            var query = from order in orderDataSet1.SalesOrderHeader
                        join detail in orderDataSet1.SalesOrderDetail on order.SalesOrderID equals detail.SalesOrderID
                        where order.TotalDue > 1000
                        where detail.UnitPriceDiscount > 0
                        select new
                        {
                            order.SalesOrderID,
                            order.AccountNumber,
                            order.TotalDue,
                            detail.UnitPriceDiscount
                        };

            //2.2 From Join
            //var query = from order in orderDataSet1.SalesOrderHeader
            //            from detail in orderDataSet1.SalesOrderDetail
            //            where order.SalesOrderID == detail.SalesOrderID
            //            where order.TotalDue > 50000
            //            where detail.UnitPriceDiscount > 0
            //            select new
            //            {
            //                order.SalesOrderID,
            //                order.AccountNumber,
            //                order.TotalDue,
            //                detail.UnitPriceDiscount
            //            }; 

            //2.3 GroupJoin
            //var query = orderDataSet1.SalesOrderHeader
            //            .GroupJoin( orderDataSet1.SalesOrderDetail,
            //                        h => h.SalesOrderID,
            //                        d => d.SalesOrderID,
            //                        ( header, detail ) => new
            //                        {
            //                            header.SalesOrderID,
            //                            header.TotalDue,
            //                            ItemCount = detail.Count( ),
            //                            AvgItemPrice = detail.Average( d => d.UnitPrice )
            //                        } )
            //            .Where( r => r.TotalDue > 1000 && r.ItemCount < 2 )
            //            .Select( r => r );

            dataGridView1.DataSource = query.ToList( );
        }
    }
}