﻿//Author: Rodolfo Finochietti - http://weblogs.shockbyte.com.ar/rodolfof
using System;
using System.Data;
using System.Linq;

namespace LINQToDataSet.UntypedDataSet
{
    static class Program
    {
        [STAThread]
        static void Main( string[] args )
        {
            DataSet ds = Utils.CreateTestDataset( );

            /* 1.1 - AsEnumerable */
            var products = ds.Tables[ "Products" ].AsEnumerable( );

            /* 1.2 - Simple Query */
            var query = from p in products
                        where p[ "ProductName" ].ToString( ).StartsWith( "C" )
                        select p;

            foreach ( var product in query )
                Console.WriteLine( product[ "ProductName" ].ToString( ) );

            /* 1.3 - Field<> methods */
            //var productsInStock = from p in products
            //                      where p.Field<int>( "UnitsInStock" ) > 0
            //                      select new
            //                      {
            //                          ProductName = p.Field<string>( "ProductName" ),
            //                          UnitPrice = p.Field<decimal>( "UnitPrice" )
            //                      };

            //foreach ( var product in productsInStock )
            //    Console.WriteLine( "{0} - {1}", product.ProductName, product.UnitPrice );

            /*1.4 - Orderby methods */
            //var productsInStock = from p in products
            //                      where p.Field<int>( "UnitsInStock" ) > 0
            //                      orderby p.Field<string>( "ProductName" )
            //                      select new
            //                      {
            //                          ProductName = p.Field<string>( "ProductName" ),
            //                          UnitPrice = p.Field<decimal>( "UnitPrice" )
            //                      };

            //Utils.DumpObject( productsInStock );

            /*1.5 - Grouping */
            //var productGroups = from p in products
            //                    group p by p.Field<string>( "Category" ) into g
            //                    select new
            //                    {
            //                        Category = g.Key,
            //                        Count = g.Count( ),
            //                        Products = g
            //                    };

            //foreach ( var pg in productGroups )
            //{
            //    Console.WriteLine( "{0} - {1}", pg.Category, pg.Count );
            //    foreach ( var p in pg.Products )
            //        Console.WriteLine( "\t" + p.Field<string>( "ProductName" ) );
            //}
            
            Console.ReadLine( );
        }
    }
}